﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SPWSUtilities;

namespace SPFileDownloader
{
    class Program
    {
        static void Main(string[] args)
        {
            bool pause = false;
            FileDownloader downloader = new FileDownloader();
            try
            {
                if (args.Length < 5)
                    throw new Exception("Not enough arguments.");

                ServiceWrapper services = new ServiceWrapper();
                services.WebUrl = args[0];
                services.User = args[3];
                services.Password = args[4];
               

                downloader.TargetDir = args[2];
                downloader.Wrapper = services;
                if (args.Length >= 6)
                {
                    string sSwitches = args[5].ToLower();
                    services.FormAuthentication = sSwitches.Contains('f');
                    downloader.Recursive = sSwitches.Contains('r');
                    downloader.Overwrite = sSwitches.Contains('o');
                    pause = sSwitches.Contains('p');
                }
                downloader.DownloadListItems(args[1]);
            }
            catch (Exception ex)
            {
                ShowHelp();
                Console.WriteLine(); Console.WriteLine();
                Console.WriteLine("Error: " + ex.Message);
                Console.WriteLine(ex.StackTrace);
                //Console.WriteLine("Web url: {0}\r\nTarget Directory: {1}\r\nUser/pw: {2}/{3}",
                //    downloader.WebUrl, downloader.TargetDir, downloader.User, downloader.Password);
            }

            if (pause)
            {
                Console.WriteLine("\nPress any key.");
                Console.ReadKey();
            }
            else
            {
                Console.WriteLine("done.");
            }
        }

        static void ShowHelp()
        {
            Console.Write(@"Usage:
    SPFileDownloader <web url> <list | list/folder/subfolder> <target dir local> <username> <password> [switches]
    switches:
    f   Use form-based authentication
    r   Recursive - recurse through subfolders
    o   Overwrite - overwrite local files
    p   Pause - pause for user input after run");
        }
    }
}
