﻿using System.Data;

namespace SPWSUtilities
{
    internal class FileRef
    {
        private FileRef() { }

        /// <summary>
        /// Create a file reference object from one row of data returned by the Lists service
        /// procedure GetListItems()
        /// </summary>
        internal static FileRef Create (DataRow row, string webUrl)
        {
            FileRef fr = new FileRef();

            string fileRef = row["ows_FileRef"].ToString();
            string relativePath = fileRef.Split(new char[] { '#' })[1].ToString();
            char[] separator = new char[] { '/' };
            fr.FullUrl = webUrl.Split(separator)[0].ToString() + "//" + webUrl.Split(separator)[2].ToString() + "/" + relativePath;
            string[] relativePathParts = relativePath.Split(separator);
            fr.FileName = relativePathParts[relativePathParts.Length - 1];

            try
            {
                fr.DocIcon = row["ows_DocIcon"].ToString();
            }
            catch
            {
                fr.DocIcon = string.Empty;
            }

            fr.WebUrl = webUrl;

            return fr;
        }

        public string FileName { get; private set; }

        public string DocIcon { get; private set; }

        public string FullUrl { get; private set; }

        public string WebUrl { get; private set; }
    }
}
