﻿using System;
using SPWSUtilities.WPFormAuth;
using System.Web.Services.Protocols;
using System.Net;

namespace SPWSUtilities
{
    public class ServiceWrapper
    {
        public string User { get; set; }
        public string Password { get; set; }
        public bool FormAuthentication { get; set; }
        public string WebUrl { get; set; }

        public void InitService(HttpWebClientProtocol service)
        {
            if (this.FormAuthentication)
            {
                Authentication spAuthentication = new Authentication();
                spAuthentication.Url = WebUrl + @"/_vti_bin/Authentication.asmx"; ;
                spAuthentication.CookieContainer = new CookieContainer();

                //Try to login to SharePoint site with Form based authentication
                LoginResult loginResult = spAuthentication.Login(User, Password);
                Cookie cookie = new Cookie();
                //If login is successfull
                if (loginResult.ErrorCode == LoginErrorCode.NoError)
                {
                    CookieCollection cookies = spAuthentication.CookieContainer.GetCookies(new Uri(spAuthentication.Url));
                    cookie = cookies[loginResult.CookieName];
                    service.CookieContainer = new CookieContainer();
                    service.CookieContainer.Add(cookie);
                }
            }
            else
            {
                service.PreAuthenticate = true;
                service.Credentials = new NetworkCredential(User, Password);
            }
        }

        WSLists.Lists listsService = null;
        internal WSLists.Lists ListsServiceInstance()
        {
            if (listsService == null)
            {
                listsService = new WSLists.Lists();
                InitService(listsService);
                listsService.Url = WebUrl + "/_vti_bin/lists.asmx";
            }
            return listsService;
        }

        private WSCopy.Copy copyService = null;
        /// <summary>
        /// Use this method to ensure that we only instantiate the copy service if necessary.
        /// </summary>
        internal WSCopy.Copy CopyServiceInstance
        {
            get
            {
                if (copyService == null)
                {
                    copyService = new WSCopy.Copy();
                    InitService(copyService);
                    copyService.Url = WebUrl + "/_vti_bin/copy.asmx";
                }
                return copyService;
            }
        }
    }
}
